<?
/*
Directory Listing Script - Version 2
====================================
Script Author: Ash Young <ash@evoluted.net>. www.evoluted.net
Layout: Manny <manny@tenka.co.uk>. www.tenka.co.uk

REQUIREMENTS
============
This script requires PHP and GD2 if you wish to use the 
thumbnail functionality.

INSTRUCTIONS
============
1) Unzip all files 
2) Edit this file, making sure everything is setup as required.
3) Upload to server
4) ??????
5) Profit!

CONFIGURATION
=============
Edit the variables in this section to make the script work as
you require.

Start Directory - To list the files contained within the current 
directory enter '.', otherwise enter the path to the directory 
you wish to list. The path must be relative to the current 
directory.
*/
$basedir = '../_ftp_';

/*
Show Thumbnails? - Set to true if you wish to use the 
scripts auto-thumbnail generation capabilities.
This requires that GD2 is installed.
*/
$showthumbnails = true; 

/*
Show Directories - Do you want to make subdirectories available?
If not set this to false
*/
$showdirs = true;

/*
Hide Files - If you wish to hide certain files or directories 
then enter their details here. The values entered are matched
against the file/directory names. If any part of the name 
matches what is entered below then it is now shown.
*/
$hide = array(
				'.htaccess',
				'.htpasswd',
				'.ftpquota',
			);
			 
/*
File Icons - If you want to add your own special file icons use 
this section below. Each entry relates to the extension of the 
given file, in the form <extension> => <filename>. 
These files must be located within the dlf directory.
*/
$filetypes = array (
				'png' => 'jpg.gif',
				'jpeg' => 'jpg.gif',
				'bmp' => 'jpg.gif',
				'jpg' => 'jpg.gif', 
				'gif' => 'gif.gif',
				'zip' => 'archive.png',
				'rar' => 'archive.png',
				'exe' => 'exe.gif',
				'setup' => 'setup.gif',
				'txt' => 'text.png',
				'htm' => 'html.gif',
				'html' => 'html.gif',
				'fla' => 'fla.gif',
				'swf' => 'swf.gif',
				'xls' => 'xls.gif',
				'doc' => 'doc.gif',
				'sig' => 'sig.gif',
				'fh10' => 'fh10.gif',
				'pdf' => 'pdf.gif',
				'psd' => 'psd.gif',
				'rm' => 'real.gif',
				'mpg' => 'video.gif',
				'mpeg' => 'video.gif',
				'mov' => 'video2.gif',
				'avi' => 'video.gif',
				'eps' => 'eps.gif',
				'gz' => 'archive.png',
				'asc' => 'sig.gif',
			);
			
/*
That's it! You are now ready to upload this script to the server.

Only edit what is below this line if you are sure that you know what you
are doing!
*/

#error_reporting(0);

if (!function_exists('imagecreatetruecolor')) {
	$showthumbnails = false;
}

$basedir = rtrim($basedir, '/') . '/';
is_dir($basedir) or die("Incorrect basedir configuration.");

$dir = trim($_GET['dir'], '/') . '/';
strpos("/$dir/", '/../') === false or die("$dir is not a valid directory.");
if ($dir == "/" || $dir == "./") {
	$dir = "";
}

$opendir = $basedir . $dir;
is_dir($opendir) or die("$dir is not a valid directory.");

$phpdir = dirname($_SERVER['PHP_SELF']) . '/';

$resdir = $phpdir . '__resource/';


if ($_GET['thumb']) {
	$file = $_GET['thumb'];
	strpos("/$file/", '/../') === false or die("$file is not a valid image file.");

	$openfile = $opendir . $file;

	file_exists($openfile) or die("$file is not a valid image file.");
	function_exists('imagecreatetruecolor') or die('GD2 not installed / configured.');

	$type = strtolower(end(explode('.', $openfile)));
	if ($type == 'jpg' || $type == 'jpeg') {
		$img = imagecreatefromjpeg($openfile);
	} elseif ($type == 'png') {
		$img = imagecreatefrompng($openfile);
	} elseif ($type == 'gif') {
		function_exists('imagecreatefromgif') or die('Your version of GD does not support GIFs');
		$img = imagecreatefromgif($file);
	} else {
		die("Error: Image type not supported");
	}

	$x = imagesx($img);
	$y = imagesy($img);

	$width = 150;
	$height = round(($y/$x) * $width);

	$tmpimage = imagecreatetruecolor($width, $height);
	imagecopyresampled($tmpimage, $img, 0, 0, 0, 0, $width, $height, $x, $y);
	imagedestroy($img);
	$img = $tmpimage;

	if ($type == 'jpg' || $type == 'jpeg') {
		header("Content-type: image/jpeg");
		imagejpeg($img, '', 65);
	} 
	elseif ($type == 'png') {
		header("Content-type: image/png");
		imagetruecolortopalette($img, false, 128);
		imagepng($img);
	} 
	elseif ($type == 'gif') {
		header("Content-type: image/png");
		imagetruecolortopalette($img, false, 128);
		imagepng($img);
	}

	exit();
}


if ($_GET['view']) {
	$file = $_GET['view'];
	strpos("/$file/", '/../') === false or die("$file is not a valid file.");

	$openfile = $opendir . $file;
	is_file($openfile) or die("$file is not a valid file.");

	$source = file_get_contents($openfile);
	$encoding = mb_detect_encoding($source, "UTF-8, GBK, BIG5");

	include_once(substr($resdir, strlen($phpdir)) . 'geshi.php');
	$geshi = new GeSHi($source);
	$ext = end(explode('.', $file));
	$lang = $geshi->get_language_name_from_extension($ext);
	if (!$lang) {
	    $lookup = array("diff" => array("patch"));
	    $lang = $geshi->get_language_name_from_extension($ext, $lookup);
	}
	$geshi->set_language($lang);
	$geshi->enable_line_numbers(GESHI_FANCY_LINE_NUMBERS, 2);
	$geshi->set_line_style('background: #fcfcfc;', 'background: #f0f0f0;');
	$geshi->set_overall_style('font-family:monospace; background: #FFF; '
							  .'margin: 1em 2em 1em 2em; padding-left: 4ex;');
	$geshi->set_header_type(GESHI_HEADER_DIV);
	$geshi->enable_classes();

	if ($lang == "diff") {
	    $geshi->enable_line_numbers(GESHI_NORMAL_LINE_NUMBERS);
	    $geshi->set_regexps_style(0, '');
	    $geshi->set_regexps_style(3, 'background: #102E4E; color: #EEE;');
	    $geshi->set_regexps_style(4, 'background: #102E4E; color: #EEE;');
	    $geshi->set_regexps_style(7, 'background: #EEE;', true);
	    $geshi->set_regexps_style(8, 'background: #EEE;', true);
	}
	
	echo '<html><head>';
	if ($encoding) {
		echo '<meta http-equiv="Content-Type" content="text/html; charset='.$encoding.'" />';
	}
	echo '<title>'.htmlspecialchars($file).'</title>';
	echo '<style type="text/css"><!--';
	echo 'body { background: #e0e8ef }';
	echo $geshi->get_stylesheet();
	echo '--></style></head><body>';
	echo $geshi->parse_code();
	echo '</body></html>';

	exit();
}

if ($_GET['down']) {
	$file = $_GET['down'];
	strpos("/$file/", '/../') === false or die("$file is not a valid file.");

	$openfile = $opendir . $file;
	is_file($openfile) or die("$file is not a valid file.");

	header('Content-Description: File Transfer');
	header('Content-Type: application/octet-stream');
	header('Content-Disposition: attachment; filename=' . $file);
	header('Content-Transfer-Encoding: binary');
	header('Expires: 0');
	header('Cache-Control: must-revalidate, post-check=0, pre-check=0');
	header('Pragma: public');
	header('Content-Length: ' . filesize($openfile));

	readfile($openfile);

	exit();
}

clearstatcache();

$dirlist = array();
$filelist = array();

if ($handle = opendir($opendir)) {
	while (false !== ($file = readdir($handle))) { 
		$n++;

		//first see if this file is required in the listing
		if ($file == "." || $file == "..") {
			continue;
		}

		if (in_array($file, $hide) || in_array('/'.$dir.$file, $hide)) {
			continue;
		}
		
		$location = $opendir . $file;
		if (is_dir($location)) {
			if (!$showdirs) {
				continue;
			}
			if ($_GET['sort'] == 'date') {
				$key = filemtime($location) . ".$n";
			} else {
				$key = $n;
			}
			$dirlist[$key] = $file . "/";
		} else {
			$n++;
			if ($_GET['sort'] == 'date') {
				$key = filemtime($location) . ".$n";
			} elseif ($_GET['sort'] == 'size') {
				$key = filesize($location) . ".$n";
			} else {
				$key = $n;
			}
			$filelist[$key] = $file;
		}
	}
	closedir($handle); 
}

//sort our files
if ($_GET['sort'] == 'date') {
	ksort($dirlist, SORT_NUMERIC);
	ksort($filelist, SORT_NUMERIC);
}
elseif ($_GET['sort'] == 'size') {
	natcasesort($dirlist); 
	ksort($filelist, SORT_NUMERIC);
}
else {
	natcasesort($dirlist); 
	natcasesort($filelist);
}

//order correctly
if ($_GET['order'] == "desc" && $_GET['sort'] != "size") {
	$dirlist = array_reverse($dirlist);
}
if ($_GET['order'] == "desc") {
	$filelist = array_reverse($filelist);
}
$dirlist = array_values($dirlist); 
$filelist = array_values($filelist);

?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<title>Directory Listing of <?=dirname($_SERVER['PHP_SELF']).'/'.$dir;?></title>
<link rel="stylesheet" type="text/css" href="<?=$resdir;?>styles.css" />
</head>
<body>
<div id="container">
  <h1>Directory Listing of <?=$phpdir.$dir;?></h1>
  <div id="breadcrumbs"> <a href="<?=$phpdir;?>">home</a> 
	<?
$sofar = '';
foreach (split('/', $dir) as $i) {
	if ($i) {
		$updir = $sofar;
		$sofar .= $i . '/';
		echo ' &gt; <a href="'. $phpdir . $sofar . '">' . $i . '</a>';
	}
}

foreach (array('name', 'size', 'date') as $i) {
	$query[$i] = $phpdir . $dir . '?sort=' . $i . '&amp;order=';
	if ($_GET['sort'] == $i && $_GET['order'] == 'asc') {
		$query[$i] .= 'desc';
	} else {
		$query[$i] .= 'asc';
	}
}
$arrow[$_GET['sort']] = ($_GET['order'] == 'asc') ? '↑' : '↓';

  ?>
  </div>
  <div id="listingcontainer">
    <div id="listingheader"> 
	<div id="headerfile"><a href="<?=$query['name'];?>">File<?=$arrow['name'];?></a></div>
	<div id="headersize"><a href="<?=$query['size'];?>">Size<?=$arrow['size'];?></a></div>
	<div id="headermodified"><a href="<?=$query['date'];?>">Last Modified<?=$arrow['date'];?></a></div>
	</div>
    <div id="listing">
	<?
if (isset($updir)) {
	$class = 'b';
	?>
	<div><a href="<?=$phpdir.$updir;?>" class="<?=$class;?>"><img src="<?=$resdir;?>dirup.png" alt="Folder" /><strong>..</strong> <em>-</em> <?=date("M d Y h:i:s A", filemtime($basedir.$updir));?></a></div>
	<?
}
foreach ($dirlist as $i) {
	$class = ($class == 'b') ? 'w' : 'b';

	?>
	<div><a href="<?=$i;?>" class="<?=$class;?>"><img src="<?=$resdir;?>folder.png" alt="<?=$i;?>" /><strong><?=$i;?></strong> <em>-</em> <?=date("M d Y h:i:s A", filemtime($opendir.$i));?></a></div>
	<?
}
	
foreach ($filelist as $i) {
	$icon = 'unknown.png';
	$ext = strtolower(substr($i, strrpos($i, '.')+1));
	$supportedimages = array('gif', 'png', 'jpeg', 'jpg');
		
	if($showthumbnails && in_array($ext, $supportedimages)) {
		$thumb = '<span><img src="?thumb=' . $i . '" alt="' . $i . '" /></span>';
	} else {
		$thumb = '';
	}
		
	if ($filetypes[$ext]) {
		$icon = $filetypes[$ext];
	}
		
	if(strlen($i)>43) {
		$filename = substr($i, 0, 40) . '...';
	}

	$size = filesize($opendir.$i);
	foreach (array('', 'K', 'M') as $j) {
		$size /= 1024;
		if ($size < 1) {
			break;
		}
	}
	$size = sprintf('%.2f', $size * 1024);
	$size = rtrim(substr(rtrim($size, '0'), 0, (strlen($size) > 5) ? strlen($size) - 3 : 4), '.') . $j;

	$class = ($class == 'b') ? 'w' : 'b';
		
	?>
	<div><a href="<?=$i;?>" class="<?=$class;?>"><img src="<?=$resdir.$icon;?>" alt="<?=$i;?>" /><strong><?=$i;?></strong> <em><?=$size;?></em> <?=date ("M d Y h:i:s A", filemtime($opendir.$i));?><?=$thumb;?></a></div>
	<?
}	
	?></div>
  </div>
</div>
<div id="copy">Directory Listing Script &copy;2005 <a href="http://evoluted.net/">Ash Young</a>. Design by <a href="http://www.tenka.co.uk/">Manny</a>.</div>
</body>
</html>
